action player1
{
	var movement_speed = 7; // movement speed
	player = my; // I'm the player
	my.invisible = on;
	my.skill40 = 100; // let's store the health in skill40
	while (my.skill40 > 0)
	{
		player.pan -= 7 * mouse_force.x * time;
		camera.x = player.x;
		camera.y = player.y;
		camera.z = player.z + 50 + 1.1 * sin(my.skill44); // play with 50 and 1.1
		camera.pan = player.pan;
		camera.tilt += 5 * mouse_force.y * time;
		vec_set (temp.x, my.x); // trace 10,000 quants below the player
		temp.z -= 10000;
		temp.z = -c_trace (my.x, temp.x, ignore_me | ignore_passable | use_box);
		temp.x = movement_speed * (key_w - key_s) * time;
		temp.y = movement_speed * (key_a - key_d) * 0.6 * time;
		c_move (my, temp.x, nullvector, ignore_passable | glide);
		if (key_w + key_s > 0) // if the player is walking
		{
			my.skill44 += 25 * time;
			ent_cycle("walk", my.skill46); // play its "walk" frames animation
			my.skill46 += 5 * time;
			my.skill46 %= 100; // loop the animation
		}
		else // if the player is standing
		{
			ent_cycle("stand", my.skill48); // play the "stand" frames animation
			my.skill48 += 2 * time; // "stand" animation speed
			my.skill48 %= 100; // loop animation
		}
		wait (1);
	}
	// the player is dead here
	my.skill40 = 0; // use the same skill40 to control the "death" animation
	my.invisible = off; // let's show player's body now
	while (my.skill40 < 90)
	{ 
		ent_cycle("death", my.skill40);
		my.skill40 += 2 * time; // "death" animation speed
		camera.roll -= 0.3 * time;
		camera.tilt += 0.8 * time;
		wait (1); 
	} 
	my.passable = on; // player's corpse will be passable from now on
}


// weapon tester - Aum55's workshop homework

function got_shot(); // function prototype

action shootable_entity // attach this action to your helpless enemies
{
	my.enable_impact = on; // the enemy is sensitive to impact with player's bullets
	my.event = got_shot; // and runs its event function when it is hit
}

function got_shot()
{
	var anim_percentage = 0;
	my.event = null; // the enemy is dead, so it should stop reacting to other bullets from now on
	while (anim_percentage < 100) // this loop will run until the "death" animation percentage reaches 100%
	{
		ent_animate(my, "death", anim_percentage, null); // play the "death" animation only once
		anim_percentage += 3 * time; // "3" controls the animation speed
		wait (1);
	}
	my.passable = on; // allow the player to pass through the corpse now
}
